// A Bison parser, made by GNU Bison 3.6.4.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2020 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.



// First part of user prologue.
#line 31 "src/parser.yy"

#include <iostream>

#include "driver.h"

void yyerror(bpftrace::Driver &driver, const char *s);

#line 49 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"


#include "parser.tab.hh"




#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 4 "src/parser.yy"
namespace  bpftrace  {
#line 147 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"

  /// Build a parser object.
   Parser :: Parser  (bpftrace::Driver &driver_yyarg, void *yyscanner_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg),
      yyscanner (yyscanner_yyarg)
  {}

   Parser ::~ Parser  ()
  {}

   Parser ::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------------.
  | symbol kinds.  |
  `---------------*/



  // by_state.
   Parser ::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

   Parser ::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
   Parser ::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
   Parser ::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

   Parser ::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

   Parser ::symbol_kind_type
   Parser ::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

   Parser ::stack_symbol_type::stack_symbol_type ()
  {}

   Parser ::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case 77: // attach_point
        value.YY_MOVE_OR_COPY< ast::AttachPoint * > (YY_MOVE (that.value));
        break;

      case 76: // attach_points
        value.YY_MOVE_OR_COPY< ast::AttachPointList * > (YY_MOVE (that.value));
        break;

      case 94: // call
        value.YY_MOVE_OR_COPY< ast::Call * > (YY_MOVE (that.value));
        break;

      case 91: // expr
      case 92: // pre_post_op
      case 97: // map_or_var
        value.YY_MOVE_OR_COPY< ast::Expression * > (YY_MOVE (that.value));
        break;

      case 98: // vargs
        value.YY_MOVE_OR_COPY< ast::ExpressionList * > (YY_MOVE (that.value));
        break;

      case 90: // int
        value.YY_MOVE_OR_COPY< ast::Integer * > (YY_MOVE (that.value));
        break;

      case 95: // map
        value.YY_MOVE_OR_COPY< ast::Map * > (YY_MOVE (that.value));
        break;

      case 81: // param
        value.YY_MOVE_OR_COPY< ast::PositionalParameter * > (YY_MOVE (that.value));
        break;

      case 79: // pred
        value.YY_MOVE_OR_COPY< ast::Predicate * > (YY_MOVE (that.value));
        break;

      case 75: // probe
        value.YY_MOVE_OR_COPY< ast::Probe * > (YY_MOVE (that.value));
        break;

      case 74: // probes
        value.YY_MOVE_OR_COPY< ast::ProbeList * > (YY_MOVE (that.value));
        break;

      case 83: // semicolon_ended_stmt
      case 85: // block_stmt
      case 86: // if_stmt
      case 88: // stmt
      case 89: // compound_assignment
        value.YY_MOVE_OR_COPY< ast::Statement * > (YY_MOVE (that.value));
        break;

      case 82: // block
      case 84: // stmts
      case 87: // block_or_if
        value.YY_MOVE_OR_COPY< ast::StatementList * > (YY_MOVE (that.value));
        break;

      case 80: // ternary
        value.YY_MOVE_OR_COPY< ast::Ternary * > (YY_MOVE (that.value));
        break;

      case 96: // var
        value.YY_MOVE_OR_COPY< ast::Variable * > (YY_MOVE (that.value));
        break;

      case 67: // "integer"
        value.YY_MOVE_OR_COPY< long > (YY_MOVE (that.value));
        break;

      case 55: // "builtin"
      case 56: // "call"
      case 57: // "call_builtin"
      case 58: // "identifier"
      case 59: // "path"
      case 60: // "preprocessor directive"
      case 61: // "struct definition"
      case 62: // "enum"
      case 63: // "string"
      case 64: // "map"
      case 65: // "variable"
      case 66: // "positional parameter"
      case 68: // "stack_mode"
      case 73: // c_definitions
      case 78: // attach_point_def
      case 93: // ident
        value.YY_MOVE_OR_COPY< std::string > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

   Parser ::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case 77: // attach_point
        value.move< ast::AttachPoint * > (YY_MOVE (that.value));
        break;

      case 76: // attach_points
        value.move< ast::AttachPointList * > (YY_MOVE (that.value));
        break;

      case 94: // call
        value.move< ast::Call * > (YY_MOVE (that.value));
        break;

      case 91: // expr
      case 92: // pre_post_op
      case 97: // map_or_var
        value.move< ast::Expression * > (YY_MOVE (that.value));
        break;

      case 98: // vargs
        value.move< ast::ExpressionList * > (YY_MOVE (that.value));
        break;

      case 90: // int
        value.move< ast::Integer * > (YY_MOVE (that.value));
        break;

      case 95: // map
        value.move< ast::Map * > (YY_MOVE (that.value));
        break;

      case 81: // param
        value.move< ast::PositionalParameter * > (YY_MOVE (that.value));
        break;

      case 79: // pred
        value.move< ast::Predicate * > (YY_MOVE (that.value));
        break;

      case 75: // probe
        value.move< ast::Probe * > (YY_MOVE (that.value));
        break;

      case 74: // probes
        value.move< ast::ProbeList * > (YY_MOVE (that.value));
        break;

      case 83: // semicolon_ended_stmt
      case 85: // block_stmt
      case 86: // if_stmt
      case 88: // stmt
      case 89: // compound_assignment
        value.move< ast::Statement * > (YY_MOVE (that.value));
        break;

      case 82: // block
      case 84: // stmts
      case 87: // block_or_if
        value.move< ast::StatementList * > (YY_MOVE (that.value));
        break;

      case 80: // ternary
        value.move< ast::Ternary * > (YY_MOVE (that.value));
        break;

      case 96: // var
        value.move< ast::Variable * > (YY_MOVE (that.value));
        break;

      case 67: // "integer"
        value.move< long > (YY_MOVE (that.value));
        break;

      case 55: // "builtin"
      case 56: // "call"
      case 57: // "call_builtin"
      case 58: // "identifier"
      case 59: // "path"
      case 60: // "preprocessor directive"
      case 61: // "struct definition"
      case 62: // "enum"
      case 63: // "string"
      case 64: // "map"
      case 65: // "variable"
      case 66: // "positional parameter"
      case 68: // "stack_mode"
      case 73: // c_definitions
      case 78: // attach_point_def
      case 93: // ident
        value.move< std::string > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
   Parser ::stack_symbol_type&
   Parser ::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case 77: // attach_point
        value.copy< ast::AttachPoint * > (that.value);
        break;

      case 76: // attach_points
        value.copy< ast::AttachPointList * > (that.value);
        break;

      case 94: // call
        value.copy< ast::Call * > (that.value);
        break;

      case 91: // expr
      case 92: // pre_post_op
      case 97: // map_or_var
        value.copy< ast::Expression * > (that.value);
        break;

      case 98: // vargs
        value.copy< ast::ExpressionList * > (that.value);
        break;

      case 90: // int
        value.copy< ast::Integer * > (that.value);
        break;

      case 95: // map
        value.copy< ast::Map * > (that.value);
        break;

      case 81: // param
        value.copy< ast::PositionalParameter * > (that.value);
        break;

      case 79: // pred
        value.copy< ast::Predicate * > (that.value);
        break;

      case 75: // probe
        value.copy< ast::Probe * > (that.value);
        break;

      case 74: // probes
        value.copy< ast::ProbeList * > (that.value);
        break;

      case 83: // semicolon_ended_stmt
      case 85: // block_stmt
      case 86: // if_stmt
      case 88: // stmt
      case 89: // compound_assignment
        value.copy< ast::Statement * > (that.value);
        break;

      case 82: // block
      case 84: // stmts
      case 87: // block_or_if
        value.copy< ast::StatementList * > (that.value);
        break;

      case 80: // ternary
        value.copy< ast::Ternary * > (that.value);
        break;

      case 96: // var
        value.copy< ast::Variable * > (that.value);
        break;

      case 67: // "integer"
        value.copy< long > (that.value);
        break;

      case 55: // "builtin"
      case 56: // "call"
      case 57: // "call_builtin"
      case 58: // "identifier"
      case 59: // "path"
      case 60: // "preprocessor directive"
      case 61: // "struct definition"
      case 62: // "enum"
      case 63: // "string"
      case 64: // "map"
      case 65: // "variable"
      case 66: // "positional parameter"
      case 68: // "stack_mode"
      case 73: // c_definitions
      case 78: // attach_point_def
      case 93: // ident
        value.copy< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

   Parser ::stack_symbol_type&
   Parser ::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case 77: // attach_point
        value.move< ast::AttachPoint * > (that.value);
        break;

      case 76: // attach_points
        value.move< ast::AttachPointList * > (that.value);
        break;

      case 94: // call
        value.move< ast::Call * > (that.value);
        break;

      case 91: // expr
      case 92: // pre_post_op
      case 97: // map_or_var
        value.move< ast::Expression * > (that.value);
        break;

      case 98: // vargs
        value.move< ast::ExpressionList * > (that.value);
        break;

      case 90: // int
        value.move< ast::Integer * > (that.value);
        break;

      case 95: // map
        value.move< ast::Map * > (that.value);
        break;

      case 81: // param
        value.move< ast::PositionalParameter * > (that.value);
        break;

      case 79: // pred
        value.move< ast::Predicate * > (that.value);
        break;

      case 75: // probe
        value.move< ast::Probe * > (that.value);
        break;

      case 74: // probes
        value.move< ast::ProbeList * > (that.value);
        break;

      case 83: // semicolon_ended_stmt
      case 85: // block_stmt
      case 86: // if_stmt
      case 88: // stmt
      case 89: // compound_assignment
        value.move< ast::Statement * > (that.value);
        break;

      case 82: // block
      case 84: // stmts
      case 87: // block_or_if
        value.move< ast::StatementList * > (that.value);
        break;

      case 80: // ternary
        value.move< ast::Ternary * > (that.value);
        break;

      case 96: // var
        value.move< ast::Variable * > (that.value);
        break;

      case 67: // "integer"
        value.move< long > (that.value);
        break;

      case 55: // "builtin"
      case 56: // "call"
      case 57: // "call_builtin"
      case 58: // "identifier"
      case 59: // "path"
      case 60: // "preprocessor directive"
      case 61: // "struct definition"
      case 62: // "enum"
      case 63: // "string"
      case 64: // "map"
      case 65: // "variable"
      case 66: // "positional parameter"
      case 68: // "stack_mode"
      case 73: // c_definitions
      case 78: // attach_point_def
      case 93: // ident
        value.move< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
   Parser ::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
   Parser ::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YYUSE (yykind);
        yyo << ')';
      }
  }
#endif

  void
   Parser ::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
   Parser ::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
   Parser ::yypop_ (int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
   Parser ::debug_stream () const
  {
    return *yycdebug_;
  }

  void
   Parser ::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


   Parser ::debug_level_type
   Parser ::debug_level () const
  {
    return yydebug_;
  }

  void
   Parser ::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

   Parser ::state_type
   Parser ::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
   Parser ::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  bool
   Parser ::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
   Parser ::operator() ()
  {
    return parse ();
  }

  int
   Parser ::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            symbol_type yylookahead (yylex (driver, yyscanner));
            yyla.move (yylookahead);
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case 77: // attach_point
        yylhs.value.emplace< ast::AttachPoint * > ();
        break;

      case 76: // attach_points
        yylhs.value.emplace< ast::AttachPointList * > ();
        break;

      case 94: // call
        yylhs.value.emplace< ast::Call * > ();
        break;

      case 91: // expr
      case 92: // pre_post_op
      case 97: // map_or_var
        yylhs.value.emplace< ast::Expression * > ();
        break;

      case 98: // vargs
        yylhs.value.emplace< ast::ExpressionList * > ();
        break;

      case 90: // int
        yylhs.value.emplace< ast::Integer * > ();
        break;

      case 95: // map
        yylhs.value.emplace< ast::Map * > ();
        break;

      case 81: // param
        yylhs.value.emplace< ast::PositionalParameter * > ();
        break;

      case 79: // pred
        yylhs.value.emplace< ast::Predicate * > ();
        break;

      case 75: // probe
        yylhs.value.emplace< ast::Probe * > ();
        break;

      case 74: // probes
        yylhs.value.emplace< ast::ProbeList * > ();
        break;

      case 83: // semicolon_ended_stmt
      case 85: // block_stmt
      case 86: // if_stmt
      case 88: // stmt
      case 89: // compound_assignment
        yylhs.value.emplace< ast::Statement * > ();
        break;

      case 82: // block
      case 84: // stmts
      case 87: // block_or_if
        yylhs.value.emplace< ast::StatementList * > ();
        break;

      case 80: // ternary
        yylhs.value.emplace< ast::Ternary * > ();
        break;

      case 96: // var
        yylhs.value.emplace< ast::Variable * > ();
        break;

      case 67: // "integer"
        yylhs.value.emplace< long > ();
        break;

      case 55: // "builtin"
      case 56: // "call"
      case 57: // "call_builtin"
      case 58: // "identifier"
      case 59: // "path"
      case 60: // "preprocessor directive"
      case 61: // "struct definition"
      case 62: // "enum"
      case 63: // "string"
      case 64: // "map"
      case 65: // "variable"
      case 66: // "positional parameter"
      case 68: // "stack_mode"
      case 73: // c_definitions
      case 78: // attach_point_def
      case 93: // ident
        yylhs.value.emplace< std::string > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2:
#line 152 "src/parser.yy"
                               { driver.root_ = new ast::Program(yystack_[1].value.as < std::string > (), yystack_[0].value.as < ast::ProbeList * > ()); }
#line 997 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 3:
#line 155 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "\n" + yystack_[0].value.as < std::string > (); }
#line 1003 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 4:
#line 156 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ";\n" + yystack_[0].value.as < std::string > (); }
#line 1009 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 5:
#line 157 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ";\n" + yystack_[0].value.as < std::string > (); }
#line 1015 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 6:
#line 158 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = std::string(); }
#line 1021 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 7:
#line 161 "src/parser.yy"
                      { yylhs.value.as < ast::ProbeList * > () = yystack_[1].value.as < ast::ProbeList * > (); yystack_[1].value.as < ast::ProbeList * > ()->push_back(yystack_[0].value.as < ast::Probe * > ()); }
#line 1027 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 8:
#line 162 "src/parser.yy"
                      { yylhs.value.as < ast::ProbeList * > () = new ast::ProbeList; yylhs.value.as < ast::ProbeList * > ()->push_back(yystack_[0].value.as < ast::Probe * > ()); }
#line 1033 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 9:
#line 165 "src/parser.yy"
                                 { yylhs.value.as < ast::Probe * > () = new ast::Probe(yystack_[2].value.as < ast::AttachPointList * > (), yystack_[1].value.as < ast::Predicate * > (), yystack_[0].value.as < ast::StatementList * > ()); }
#line 1039 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 10:
#line 168 "src/parser.yy"
                                               { yylhs.value.as < ast::AttachPointList * > () = yystack_[2].value.as < ast::AttachPointList * > (); yystack_[2].value.as < ast::AttachPointList * > ()->push_back(yystack_[0].value.as < ast::AttachPoint * > ()); }
#line 1045 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 11:
#line 169 "src/parser.yy"
                                               { yylhs.value.as < ast::AttachPointList * > () = new ast::AttachPointList; yylhs.value.as < ast::AttachPointList * > ()->push_back(yystack_[0].value.as < ast::AttachPoint * > ()); }
#line 1051 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 12:
#line 172 "src/parser.yy"
                                               { yylhs.value.as < ast::AttachPoint * > () = new ast::AttachPoint(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1057 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 13:
#line 175 "src/parser.yy"
                                             { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + yystack_[0].value.as < std::string > (); }
#line 1063 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 14:
#line 179 "src/parser.yy"
                                             { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "\"" + std::regex_replace(yystack_[0].value.as < std::string > (), std::regex("\""), "\\\"") + "\""; }
#line 1069 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 15:
#line 180 "src/parser.yy"
                                             { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + yystack_[0].value.as < std::string > (); }
#line 1075 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 16:
#line 181 "src/parser.yy"
                                             { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + std::to_string(yystack_[0].value.as < long > ()); }
#line 1081 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 17:
#line 182 "src/parser.yy"
                                             { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ":"; }
#line 1087 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 18:
#line 183 "src/parser.yy"
                                             { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "."; }
#line 1093 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 19:
#line 184 "src/parser.yy"
                                             { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "+"; }
#line 1099 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 20:
#line 185 "src/parser.yy"
                                             { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "*"; }
#line 1105 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 21:
#line 186 "src/parser.yy"
                                             { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "["; }
#line 1111 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 22:
#line 187 "src/parser.yy"
                                             { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "]"; }
#line 1117 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 23:
#line 188 "src/parser.yy"
                                             { yylhs.value.as < std::string > () = ""; }
#line 1123 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 24:
#line 191 "src/parser.yy"
                        { yylhs.value.as < ast::Predicate * > () = new ast::Predicate(yystack_[1].value.as < ast::Expression * > (), yylhs.location); }
#line 1129 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 25:
#line 192 "src/parser.yy"
                        { yylhs.value.as < ast::Predicate * > () = nullptr; }
#line 1135 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 26:
#line 195 "src/parser.yy"
                                    { yylhs.value.as < ast::Ternary * > () = new ast::Ternary(yystack_[4].value.as < ast::Expression * > (), yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::Expression * > (), yylhs.location); }
#line 1141 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 27:
#line 198 "src/parser.yy"
                   {
                     try {
                       yylhs.value.as < ast::PositionalParameter * > () = new ast::PositionalParameter(PositionalParameterType::positional, std::stol(yystack_[0].value.as < std::string > ().substr(1, yystack_[0].value.as < std::string > ().size()-1)), yylhs.location);
                     } catch (std::exception const& e) {
                       error(yystack_[0].location, "param " + yystack_[0].value.as < std::string > () + " is out of integer range [1, " +
                             std::to_string(std::numeric_limits<long>::max()) + "]");
                       YYERROR;
                     }
                   }
#line 1155 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 28:
#line 207 "src/parser.yy"
                   { yylhs.value.as < ast::PositionalParameter * > () = new ast::PositionalParameter(PositionalParameterType::count, 0, yylhs.location); }
#line 1161 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 29:
#line 210 "src/parser.yy"
                          { yylhs.value.as < ast::StatementList * > () = yystack_[1].value.as < ast::StatementList * > (); }
#line 1167 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 30:
#line 213 "src/parser.yy"
                                { yylhs.value.as < ast::Statement * > () = yystack_[1].value.as < ast::Statement * > (); }
#line 1173 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 31:
#line 216 "src/parser.yy"
                                   { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); yystack_[0].value.as < ast::StatementList * > ()->insert(yystack_[0].value.as < ast::StatementList * > ()->begin(), yystack_[1].value.as < ast::Statement * > ()); }
#line 1179 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 32:
#line 217 "src/parser.yy"
                                   { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); yystack_[0].value.as < ast::StatementList * > ()->insert(yystack_[0].value.as < ast::StatementList * > ()->begin(), yystack_[1].value.as < ast::Statement * > ()); }
#line 1185 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 33:
#line 218 "src/parser.yy"
                                   { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; yylhs.value.as < ast::StatementList * > ()->push_back(yystack_[0].value.as < ast::Statement * > ()); }
#line 1191 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 34:
#line 219 "src/parser.yy"
                                   { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; }
#line 1197 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 35:
#line 222 "src/parser.yy"
                                      { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1203 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 36:
#line 223 "src/parser.yy"
                                      { yylhs.value.as < ast::Statement * > () = new ast::Unroll(yystack_[2].value.as < long > (), yystack_[0].value.as < ast::StatementList * > ()); }
#line 1209 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 37:
#line 226 "src/parser.yy"
                                                 { yylhs.value.as < ast::Statement * > () = new ast::If(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::StatementList * > ()); }
#line 1215 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 38:
#line 227 "src/parser.yy"
                                                 { yylhs.value.as < ast::Statement * > () = new ast::If(yystack_[4].value.as < ast::Expression * > (), yystack_[2].value.as < ast::StatementList * > (), yystack_[0].value.as < ast::StatementList * > ()); }
#line 1221 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 39:
#line 230 "src/parser.yy"
                           { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); }
#line 1227 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 40:
#line 231 "src/parser.yy"
                           { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; yylhs.value.as < ast::StatementList * > ()->emplace_back(yystack_[0].value.as < ast::Statement * > ()); }
#line 1233 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 41:
#line 234 "src/parser.yy"
                           { yylhs.value.as < ast::Statement * > () = new ast::ExprStatement(yystack_[0].value.as < ast::Expression * > ()); }
#line 1239 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 42:
#line 235 "src/parser.yy"
                           { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1245 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 43:
#line 236 "src/parser.yy"
                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1251 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 44:
#line 237 "src/parser.yy"
                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1257 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 45:
#line 240 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::LEFT,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1263 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 46:
#line 241 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::LEFT,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1269 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 47:
#line 242 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::RIGHT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1275 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 48:
#line 243 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::RIGHT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1281 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 49:
#line 244 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::PLUS,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1287 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 50:
#line 245 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::PLUS,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1293 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 51:
#line 246 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::MINUS, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1299 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 52:
#line 247 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::MINUS, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1305 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 53:
#line 248 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::MUL,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1311 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 54:
#line 249 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::MUL,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1317 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 55:
#line 250 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::DIV,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1323 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 56:
#line 251 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::DIV,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1329 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 57:
#line 252 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::MOD,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1335 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 58:
#line 253 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::MOD,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1341 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 59:
#line 254 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::BAND,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1347 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 60:
#line 255 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::BAND,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1353 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 61:
#line 256 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::BOR,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1359 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 62:
#line 257 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::BOR,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1365 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 63:
#line 258 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::BXOR,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1371 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 64:
#line 259 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::BXOR,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location)); }
#line 1377 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 65:
#line 262 "src/parser.yy"
                   { yylhs.value.as < ast::Integer * > () = new ast::Integer(-1 * yystack_[0].value.as < long > (), yylhs.location); }
#line 1383 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 66:
#line 263 "src/parser.yy"
                   { yylhs.value.as < ast::Integer * > () = new ast::Integer(yystack_[0].value.as < long > (), yylhs.location); }
#line 1389 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 67:
#line 266 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Integer * > (); }
#line 1395 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 68:
#line 267 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::String(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1401 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 69:
#line 268 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Builtin(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1407 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 70:
#line 269 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Builtin(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1413 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 71:
#line 270 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Identifier(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1419 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 72:
#line 271 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::StackMode(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1425 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 73:
#line 272 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Ternary * > (); }
#line 1431 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 74:
#line 273 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::PositionalParameter * > (); }
#line 1437 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 75:
#line 274 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1443 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 76:
#line 275 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Call * > (); }
#line 1449 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 77:
#line 276 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = yystack_[1].value.as < ast::Expression * > (); }
#line 1455 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 78:
#line 277 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::EQ, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1461 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 79:
#line 278 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::NE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1467 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 80:
#line 279 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::LE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1473 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 81:
#line 280 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::GE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1479 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 82:
#line 281 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::LT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1485 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 83:
#line 282 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::GT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1491 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 84:
#line 283 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::LAND,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1497 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 85:
#line 284 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::LOR,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1503 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 86:
#line 285 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::LEFT,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1509 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 87:
#line 286 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::RIGHT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1515 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 88:
#line 287 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::PLUS,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1521 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 89:
#line 288 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::MINUS, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1527 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 90:
#line 289 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::MUL,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1533 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 91:
#line 290 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::DIV,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1539 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 92:
#line 291 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::MOD,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1545 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 93:
#line 292 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::BAND,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1551 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 94:
#line 293 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::BOR,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1557 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 95:
#line 294 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::BXOR,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1563 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 96:
#line 295 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::LNOT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1569 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 97:
#line 296 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::BNOT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1575 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 98:
#line 297 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::MINUS, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1581 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 99:
#line 298 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::MUL,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1587 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 100:
#line 299 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::FieldAccess(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < std::string > (), yystack_[1].location); }
#line 1593 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 101:
#line 300 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::FieldAccess(new ast::Unop(token::MUL, yystack_[2].value.as < ast::Expression * > (), yystack_[1].location), yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1599 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 102:
#line 301 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::ArrayAccess(yystack_[3].value.as < ast::Expression * > (), yystack_[1].value.as < ast::Expression * > (), yystack_[2].location + yystack_[0].location); }
#line 1605 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 103:
#line 302 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Cast(yystack_[2].value.as < std::string > (), false, yystack_[0].value.as < ast::Expression * > (), yystack_[3].location + yystack_[1].location); }
#line 1611 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 104:
#line 303 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Cast(yystack_[3].value.as < std::string > (), true, yystack_[0].value.as < ast::Expression * > (), yystack_[4].location + yystack_[1].location); }
#line 1617 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 105:
#line 304 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1623 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 106:
#line 308 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::INCREMENT, yystack_[1].value.as < ast::Expression * > (), true, yystack_[0].location); }
#line 1629 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 107:
#line 309 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::DECREMENT, yystack_[1].value.as < ast::Expression * > (), true, yystack_[0].location); }
#line 1635 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 108:
#line 310 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::INCREMENT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1641 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 109:
#line 311 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::DECREMENT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1647 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 110:
#line 312 "src/parser.yy"
                                   { error(yystack_[1].location, "The ++ operator must be applied to a map or variable"); YYERROR; }
#line 1653 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 111:
#line 313 "src/parser.yy"
                                   { error(yystack_[1].location, "The ++ operator must be applied to a map or variable"); YYERROR; }
#line 1659 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 112:
#line 314 "src/parser.yy"
                                   { error(yystack_[1].location, "The -- operator must be applied to a map or variable"); YYERROR; }
#line 1665 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 113:
#line 315 "src/parser.yy"
                                   { error(yystack_[1].location, "The -- operator must be applied to a map or variable"); YYERROR; }
#line 1671 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 114:
#line 318 "src/parser.yy"
                      { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1677 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 115:
#line 319 "src/parser.yy"
                      { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1683 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 116:
#line 320 "src/parser.yy"
                      { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1689 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 117:
#line 321 "src/parser.yy"
                      { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1695 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 118:
#line 322 "src/parser.yy"
                      { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1701 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 119:
#line 325 "src/parser.yy"
                                    { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[2].value.as < std::string > (), yylhs.location); }
#line 1707 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 120:
#line 326 "src/parser.yy"
                                    { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 1713 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 121:
#line 327 "src/parser.yy"
                                    { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[2].value.as < std::string > (), yylhs.location); }
#line 1719 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 122:
#line 328 "src/parser.yy"
                                    { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 1725 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 123:
#line 329 "src/parser.yy"
                                    { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 1731 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 124:
#line 330 "src/parser.yy"
                                    { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 1737 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 125:
#line 331 "src/parser.yy"
                                    { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 1743 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 126:
#line 332 "src/parser.yy"
                                    { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 1749 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 127:
#line 333 "src/parser.yy"
                                    { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 1755 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 128:
#line 334 "src/parser.yy"
                                    { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 1761 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 129:
#line 337 "src/parser.yy"
                        { yylhs.value.as < ast::Map * > () = new ast::Map(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1767 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 130:
#line 338 "src/parser.yy"
                        { yylhs.value.as < ast::Map * > () = new ast::Map(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 1773 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 131:
#line 341 "src/parser.yy"
          { yylhs.value.as < ast::Variable * > () = new ast::Variable(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1779 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 132:
#line 344 "src/parser.yy"
                 { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Variable * > (); }
#line 1785 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 133:
#line 345 "src/parser.yy"
                 { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Map * > (); }
#line 1791 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 134:
#line 348 "src/parser.yy"
                       { yylhs.value.as < ast::ExpressionList * > () = yystack_[2].value.as < ast::ExpressionList * > (); yystack_[2].value.as < ast::ExpressionList * > ()->push_back(yystack_[0].value.as < ast::Expression * > ()); }
#line 1797 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;

  case 135:
#line 349 "src/parser.yy"
                       { yylhs.value.as < ast::ExpressionList * > () = new ast::ExpressionList; yylhs.value.as < ast::ExpressionList * > ()->push_back(yystack_[0].value.as < ast::Expression * > ()); }
#line 1803 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"
    break;


#line 1807 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
   Parser ::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
   Parser ::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
   Parser ::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  //  Parser ::context.
   Parser ::context::context (const  Parser & yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
   Parser ::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        int yychecklim = yylast_ - yyn + 1;
        int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }



  int
   Parser ::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
   Parser ::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short  Parser ::yypact_ninf_ = -188;

  const signed char  Parser ::yytable_ninf_ = -119;

  const short
   Parser ::yypact_[] =
  {
      83,    83,    83,    83,    20,  -188,  -188,  -188,  -188,  -188,
      33,  -188,    -6,  -188,   165,  -188,  -188,   387,    46,  -188,
    -188,  -188,  -188,  -188,  -188,  -188,  -188,  -188,  -188,  -188,
    -188,  -188,  -188,  -188,  -188,   401,  -188,   274,   461,   274,
     387,   387,   387,     2,    -7,   168,   172,  -188,    36,  -188,
    -188,  -188,   175,  -188,  -188,  -188,   523,  -188,    -5,  -188,
    -188,  -188,    61,    -8,  -188,   170,   563,  -188,  -188,  -188,
     134,  -188,  -188,    38,    38,    38,   179,   239,   253,   313,
     387,   327,   387,   387,  -188,   387,   387,   387,   387,   387,
     387,   387,   387,   387,   387,   387,   387,   387,   387,   387,
     387,   387,   387,   -41,   -41,  -188,  -188,  -188,  -188,    53,
      80,    -8,    84,    -8,  -188,    93,  -188,   681,    87,   522,
     387,    91,  -188,  -188,   681,    -1,  -188,    54,  -188,   125,
    -188,   129,    -3,  -188,   177,   602,    88,   906,   906,   234,
     234,   307,   307,   234,   234,   798,   759,   134,   134,    38,
      38,    38,   464,   837,   874,  -188,  -188,   387,    31,  -188,
    -188,  -188,  -188,   387,   387,   387,   387,   387,   387,   387,
     387,   387,   387,   387,   387,   387,   387,   387,   387,   387,
     387,   387,   387,   387,   387,    38,   387,  -188,   387,  -188,
    -188,  -188,  -188,  -188,  -188,   387,   642,   124,   681,   681,
     681,   681,   681,   681,   681,   681,   681,   681,   681,   681,
     681,   681,   681,   681,   681,   681,   681,   681,   681,   681,
      38,   681,   720,    46,    46,   119,  -188,     3,  -188,  -188,
    -188
  };

  const unsigned char
   Parser ::yydefact_[] =
  {
       6,     6,     6,     6,     0,    23,     3,     4,     5,     1,
      23,     8,    25,    11,    12,     7,    23,     0,     0,    17,
      21,    22,    19,    20,    18,   115,   116,   117,   114,    15,
      14,    16,   118,    13,    10,     0,    28,     0,     0,     0,
       0,     0,     0,    69,   116,    70,    71,    68,   129,   131,
      27,    66,    72,    73,    74,    67,     0,   105,     0,    76,
     133,   132,    75,    34,     9,    71,     0,   111,   108,    65,
      98,   113,   109,    99,    96,    97,     0,     0,     0,     0,
       0,     0,     0,     0,    24,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   110,   112,   106,   107,     0,
       0,    34,     0,    34,    35,    33,    42,    41,   133,   132,
       0,     0,    77,   125,   135,     0,   119,     0,   121,     0,
     123,     0,     0,   127,     0,     0,     0,    78,    79,    80,
      81,    86,    87,    82,    83,    84,    85,    88,    89,    90,
      91,    92,    93,    94,    95,   100,   101,     0,     0,    31,
      29,    32,    30,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   103,     0,   126,     0,   120,
     122,   124,   130,   128,   102,     0,     0,     0,    43,    45,
      47,    49,    51,    53,    55,    57,    59,    61,    63,    44,
      46,    48,    50,    52,    54,    56,    58,    60,    62,    64,
     104,   134,    26,     0,     0,    37,    36,     0,    39,    40,
      38
  };

  const short
   Parser ::yypgoto_[] =
  {
    -188,  -188,   228,  -188,   176,  -188,   169,  -188,  -188,  -188,
    -188,  -187,  -188,    14,  -188,   -31,  -188,  -188,  -188,  -188,
     -17,  -188,   -11,  -188,   -59,   -50,   155,   325
  };

  const short
   Parser ::yydefgoto_[] =
  {
      -1,     4,     5,    10,    11,    12,    13,    14,    18,    53,
      54,    64,   111,   112,   113,   114,   230,   115,   116,    55,
     124,    57,    58,    59,    60,    61,    62,   125
  };

  const short
   Parser ::yytable_[] =
  {
      56,    35,    77,    33,   118,   192,    36,    16,    63,   187,
     188,    76,   188,   119,    25,    26,    27,    28,    66,    37,
       9,    70,   105,    73,    74,    75,    67,    32,    71,  -115,
      38,    39,    40,    -2,   106,    17,   225,   226,    41,    42,
     228,  -115,   109,    80,   110,    82,   117,    43,    44,    45,
      46,    63,   118,   109,   118,    47,    48,    49,    50,    51,
      52,   119,   157,   119,   189,   135,   136,   188,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   103,   104,   107,   158,
     160,   195,   155,   156,   117,    82,   117,   162,   197,    83,
     108,   186,   163,   185,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   159,    96,   161,    97,    98,
      99,   100,   101,   102,   224,   190,   103,   104,   188,   191,
     196,    82,   188,     1,     2,     3,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    19,   220,
     227,   221,    20,    21,    97,    98,    99,    78,   222,    79,
     120,    79,   103,   104,    81,    34,    15,   193,    35,   123,
     188,    22,    68,    36,    72,  -117,   229,  -114,     0,  -114,
       0,     0,  -118,     0,     0,    23,    37,  -117,     0,  -114,
     121,  -114,     0,    24,  -118,     0,     0,    38,    39,    40,
      25,    26,    27,    28,    29,    41,    42,     0,    30,     6,
       7,     8,    31,    32,    43,    44,    45,    46,     0,     0,
       0,    82,    47,    48,    49,    50,    51,    52,    35,   126,
       0,     0,     0,    36,    89,    90,     0,     0,     0,     0,
      95,     0,    35,   128,     0,     0,    37,    36,     0,     0,
       0,     0,    96,     0,    97,    98,    99,    38,    39,    40,
      37,     0,   103,   104,     0,    41,    42,     0,     0,     0,
       0,    38,    39,    40,    43,    44,    45,    46,     0,    41,
      42,     0,    47,    48,    49,    50,    51,    52,    43,    44,
      45,    46,     0,     0,    82,     0,    47,    48,    49,    50,
      51,    52,    35,   130,     0,     0,     0,    36,     0,    25,
      26,    27,    28,    95,     0,     0,    35,   133,    48,    49,
      37,    36,    32,     0,     0,    96,     0,    97,    98,    99,
       0,    38,    39,    40,    37,   103,   104,     0,     0,    41,
      42,     0,     0,     0,     0,    38,    39,    40,    43,    44,
      45,    46,     0,    41,    42,     0,    47,    48,    49,    50,
      51,    52,    43,    44,    45,    46,     0,     0,     0,     0,
      47,    48,    49,    50,    51,    52,    35,     0,     0,     0,
       0,    36,   127,   129,   131,   132,   134,     0,     0,     0,
      35,     0,     0,     0,    37,    36,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    38,    39,    40,    37,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,    38,
      39,    40,    43,    44,    45,    46,     0,    41,    42,     0,
      47,    48,    49,    50,    51,    52,    43,    44,    45,    65,
       0,     0,     0,     0,    47,    48,    49,    50,    51,    52,
      35,    82,     0,     0,     0,    36,     0,     0,     0,     0,
      85,    86,    87,    88,    89,    90,    91,    92,    37,     0,
      95,     0,     0,     0,     0,     0,     0,     0,     0,    38,
      39,    40,    96,     0,    97,    98,    99,    41,    42,     0,
       0,     0,   103,   104,     0,     0,    43,    44,    45,    46,
       0,     0,     0,     0,    47,    48,    49,    50,    69,    52,
      82,     0,     0,     0,    83,    84,     0,   174,     0,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
       0,    96,     0,    97,    98,    99,   100,   101,   102,     0,
      82,   103,   104,   122,    83,     0,     0,     0,     0,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    96,     0,    97,    98,    99,   100,   101,   102,    82,
     194,   103,   104,    83,     0,     0,     0,     0,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      96,     0,    97,    98,    99,   100,   101,   102,     0,    82,
     103,   104,   223,    83,     0,     0,     0,     0,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      96,     0,    97,    98,    99,   100,   101,   102,    82,     0,
     103,   104,    83,     0,     0,     0,     0,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    96,
       0,    97,    98,    99,   100,   101,   102,    82,     0,   103,
     104,     0,     0,     0,     0,     0,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    96,     0,
      97,    98,    99,   100,   101,   102,    82,     0,   103,   104,
       0,     0,     0,     0,     0,    85,    86,    87,    88,    89,
      90,    91,    92,    93,     0,    95,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    96,     0,    97,
      98,    99,   100,   101,   102,    82,     0,   103,   104,     0,
       0,     0,     0,     0,    85,    86,    87,    88,    89,    90,
      91,    92,     0,     0,    95,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    96,     0,    97,    98,
      99,   100,   101,   102,    82,     0,   103,   104,     0,     0,
       0,     0,     0,    85,    86,    87,    88,    89,    90,    91,
      92,     0,     0,    95,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    96,     0,    97,    98,    99,
     100,    82,   102,     0,     0,   103,   104,     0,     0,     0,
      85,    86,    87,    88,    89,    90,    91,    92,     0,     0,
      95,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    96,    82,    97,    98,    99,   100,     0,     0,
       0,     0,   103,   104,    87,    88,    89,    90,    91,    92,
       0,     0,    95,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    96,     0,    97,    98,    99,     0,
       0,     0,     0,     0,   103,   104
  };

  const short
   Parser ::yycheck_[] =
  {
      17,     9,     9,    14,    63,     8,    14,    13,     5,    10,
      13,     9,    13,    63,    55,    56,    57,    58,    35,    27,
       0,    38,    27,    40,    41,    42,    37,    68,    39,    27,
      38,    39,    40,     0,    39,    41,   223,   224,    46,    47,
     227,    39,    50,     7,    52,     7,    63,    55,    56,    57,
      58,     5,   111,    50,   113,    63,    64,    65,    66,    67,
      68,   111,     9,   113,    10,    82,    83,    13,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    48,    49,    27,     9,
       6,     3,   103,   104,   111,     7,   113,     4,    67,    11,
      39,    10,    15,   120,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,   111,    38,   113,    40,    41,
      42,    43,    44,    45,    10,    10,    48,    49,    13,    10,
     157,     7,    13,    60,    61,    62,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,     3,   186,
      51,   188,     7,     8,    40,    41,    42,     9,   195,     9,
      10,     9,    48,    49,     9,    16,    10,    10,     9,    10,
      13,    26,    37,    14,    39,    27,   227,    27,    -1,    27,
      -1,    -1,    27,    -1,    -1,    40,    27,    39,    -1,    39,
      40,    39,    -1,    48,    39,    -1,    -1,    38,    39,    40,
      55,    56,    57,    58,    59,    46,    47,    -1,    63,     1,
       2,     3,    67,    68,    55,    56,    57,    58,    -1,    -1,
      -1,     7,    63,    64,    65,    66,    67,    68,     9,    10,
      -1,    -1,    -1,    14,    20,    21,    -1,    -1,    -1,    -1,
      26,    -1,     9,    10,    -1,    -1,    27,    14,    -1,    -1,
      -1,    -1,    38,    -1,    40,    41,    42,    38,    39,    40,
      27,    -1,    48,    49,    -1,    46,    47,    -1,    -1,    -1,
      -1,    38,    39,    40,    55,    56,    57,    58,    -1,    46,
      47,    -1,    63,    64,    65,    66,    67,    68,    55,    56,
      57,    58,    -1,    -1,     7,    -1,    63,    64,    65,    66,
      67,    68,     9,    10,    -1,    -1,    -1,    14,    -1,    55,
      56,    57,    58,    26,    -1,    -1,     9,    10,    64,    65,
      27,    14,    68,    -1,    -1,    38,    -1,    40,    41,    42,
      -1,    38,    39,    40,    27,    48,    49,    -1,    -1,    46,
      47,    -1,    -1,    -1,    -1,    38,    39,    40,    55,    56,
      57,    58,    -1,    46,    47,    -1,    63,    64,    65,    66,
      67,    68,    55,    56,    57,    58,    -1,    -1,    -1,    -1,
      63,    64,    65,    66,    67,    68,     9,    -1,    -1,    -1,
      -1,    14,    77,    78,    79,    80,    81,    -1,    -1,    -1,
       9,    -1,    -1,    -1,    27,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    38,    39,    40,    27,    -1,
      -1,    -1,    -1,    46,    47,    -1,    -1,    -1,    -1,    38,
      39,    40,    55,    56,    57,    58,    -1,    46,    47,    -1,
      63,    64,    65,    66,    67,    68,    55,    56,    57,    58,
      -1,    -1,    -1,    -1,    63,    64,    65,    66,    67,    68,
       9,     7,    -1,    -1,    -1,    14,    -1,    -1,    -1,    -1,
      16,    17,    18,    19,    20,    21,    22,    23,    27,    -1,
      26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    38,
      39,    40,    38,    -1,    40,    41,    42,    46,    47,    -1,
      -1,    -1,    48,    49,    -1,    -1,    55,    56,    57,    58,
      -1,    -1,    -1,    -1,    63,    64,    65,    66,    67,    68,
       7,    -1,    -1,    -1,    11,    12,    -1,    15,    -1,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      -1,    38,    -1,    40,    41,    42,    43,    44,    45,    -1,
       7,    48,    49,    10,    11,    -1,    -1,    -1,    -1,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    38,    -1,    40,    41,    42,    43,    44,    45,     7,
       8,    48,    49,    11,    -1,    -1,    -1,    -1,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      38,    -1,    40,    41,    42,    43,    44,    45,    -1,     7,
      48,    49,    10,    11,    -1,    -1,    -1,    -1,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      38,    -1,    40,    41,    42,    43,    44,    45,     7,    -1,
      48,    49,    11,    -1,    -1,    -1,    -1,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    38,
      -1,    40,    41,    42,    43,    44,    45,     7,    -1,    48,
      49,    -1,    -1,    -1,    -1,    -1,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    38,    -1,
      40,    41,    42,    43,    44,    45,     7,    -1,    48,    49,
      -1,    -1,    -1,    -1,    -1,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    -1,    26,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    38,    -1,    40,
      41,    42,    43,    44,    45,     7,    -1,    48,    49,    -1,
      -1,    -1,    -1,    -1,    16,    17,    18,    19,    20,    21,
      22,    23,    -1,    -1,    26,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    38,    -1,    40,    41,
      42,    43,    44,    45,     7,    -1,    48,    49,    -1,    -1,
      -1,    -1,    -1,    16,    17,    18,    19,    20,    21,    22,
      23,    -1,    -1,    26,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    38,    -1,    40,    41,    42,
      43,     7,    45,    -1,    -1,    48,    49,    -1,    -1,    -1,
      16,    17,    18,    19,    20,    21,    22,    23,    -1,    -1,
      26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    38,     7,    40,    41,    42,    43,    -1,    -1,
      -1,    -1,    48,    49,    18,    19,    20,    21,    22,    23,
      -1,    -1,    26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    38,    -1,    40,    41,    42,    -1,
      -1,    -1,    -1,    -1,    48,    49
  };

  const signed char
   Parser ::yystos_[] =
  {
       0,    60,    61,    62,    72,    73,    73,    73,    73,     0,
      74,    75,    76,    77,    78,    75,    13,    41,    79,     3,
       7,     8,    26,    40,    48,    55,    56,    57,    58,    59,
      63,    67,    68,    93,    77,     9,    14,    27,    38,    39,
      40,    46,    47,    55,    56,    57,    58,    63,    64,    65,
      66,    67,    68,    80,    81,    90,    91,    92,    93,    94,
      95,    96,    97,     5,    82,    58,    91,    93,    97,    67,
      91,    93,    97,    91,    91,    91,     9,     9,     9,     9,
       7,     9,     7,    11,    12,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    38,    40,    41,    42,
      43,    44,    45,    48,    49,    27,    39,    27,    39,    50,
      52,    83,    84,    85,    86,    88,    89,    91,    95,    96,
      10,    40,    10,    10,    91,    98,    10,    98,    10,    98,
      10,    98,    98,    10,    98,    91,    91,    91,    91,    91,
      91,    91,    91,    91,    91,    91,    91,    91,    91,    91,
      91,    91,    91,    91,    91,    93,    93,     9,     9,    84,
       6,    84,     4,    15,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    15,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    91,    10,    10,    13,    10,
      10,    10,     8,    10,     8,     3,    91,    67,    91,    91,
      91,    91,    91,    91,    91,    91,    91,    91,    91,    91,
      91,    91,    91,    91,    91,    91,    91,    91,    91,    91,
      91,    91,    91,    10,    10,    82,    82,    51,    82,    86,
      87
  };

  const signed char
   Parser ::yyr1_[] =
  {
       0,    71,    72,    73,    73,    73,    73,    74,    74,    75,
      76,    76,    77,    78,    78,    78,    78,    78,    78,    78,
      78,    78,    78,    78,    79,    79,    80,    81,    81,    82,
      83,    84,    84,    84,    84,    85,    85,    86,    86,    87,
      87,    88,    88,    88,    88,    89,    89,    89,    89,    89,
      89,    89,    89,    89,    89,    89,    89,    89,    89,    89,
      89,    89,    89,    89,    89,    90,    90,    91,    91,    91,
      91,    91,    91,    91,    91,    91,    91,    91,    91,    91,
      91,    91,    91,    91,    91,    91,    91,    91,    91,    91,
      91,    91,    91,    91,    91,    91,    91,    91,    91,    91,
      91,    91,    91,    91,    91,    91,    92,    92,    92,    92,
      92,    92,    92,    92,    93,    93,    93,    93,    93,    94,
      94,    94,    94,    94,    94,    94,    94,    94,    94,    95,
      95,    96,    97,    97,    98,    98
  };

  const signed char
   Parser ::yyr2_[] =
  {
       0,     2,     2,     2,     2,     2,     0,     2,     1,     3,
       3,     1,     1,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     0,     3,     0,     5,     1,     1,     3,
       2,     2,     2,     1,     0,     1,     5,     5,     7,     1,
       1,     1,     1,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     2,     2,     2,
       3,     3,     4,     4,     5,     1,     2,     2,     2,     2,
       2,     2,     2,     2,     1,     1,     1,     1,     1,     3,
       4,     3,     4,     3,     4,     3,     4,     3,     4,     1,
       4,     1,     1,     1,     3,     1
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const  Parser ::yytname_[] =
  {
  "\"end of file\"", "error", "\"invalid token\"", "\":\"", "\";\"",
  "\"{\"", "\"}\"", "\"[\"", "\"]\"", "\"(\"", "\")\"", "\"?\"",
  "\"end predicate\"", "\",\"", "\"$#\"", "\"=\"", "\"==\"", "\"!=\"",
  "\"<=\"", "\">=\"", "\"<<\"", "\">>\"", "\"<\"", "\">\"", "\"&&\"",
  "\"||\"", "\"+\"", "\"++\"", "\"<<=\"", "\">>=\"", "\"+=\"", "\"-=\"",
  "\"*=\"", "\"/=\"", "\"%=\"", "\"&=\"", "\"|=\"", "\"^=\"", "\"-\"",
  "\"--\"", "\"*\"", "\"/\"", "\"%\"", "\"&\"", "\"|\"", "\"^\"", "\"!\"",
  "\"~\"", "\".\"", "\"->\"", "\"if\"", "\"else\"", "\"unroll\"",
  "\"struct\"", "\"union\"", "\"builtin\"", "\"call\"", "\"call_builtin\"",
  "\"identifier\"", "\"path\"", "\"preprocessor directive\"",
  "\"struct definition\"", "\"enum\"", "\"string\"", "\"map\"",
  "\"variable\"", "\"positional parameter\"", "\"integer\"",
  "\"stack_mode\"", "DEREF", "CAST", "$accept", "program", "c_definitions",
  "probes", "probe", "attach_points", "attach_point", "attach_point_def",
  "pred", "ternary", "param", "block", "semicolon_ended_stmt", "stmts",
  "block_stmt", "if_stmt", "block_or_if", "stmt", "compound_assignment",
  "int", "expr", "pre_post_op", "ident", "call", "map", "var",
  "map_or_var", "vargs", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
   Parser ::yyrline_[] =
  {
       0,   152,   152,   155,   156,   157,   158,   161,   162,   165,
     168,   169,   172,   175,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   191,   192,   195,   198,   207,   210,
     213,   216,   217,   218,   219,   222,   223,   226,   227,   230,
     231,   234,   235,   236,   237,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   262,   263,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   308,   309,   310,   311,
     312,   313,   314,   315,   318,   319,   320,   321,   322,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   337,
     338,   341,   344,   345,   348,   349
  };

  void
   Parser ::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
   Parser ::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG


#line 4 "src/parser.yy"
} //  bpftrace 
#line 2582 "/root/rpmbuild/BUILD/bpftrace-0.10.0/parser.tab.cc"

#line 352 "src/parser.yy"


void bpftrace::Parser::error(const location &l, const std::string &m)
{
  driver.error(l, m);
}
